int M = 8; // nombre de segments
int L = 300; // longueur totale du bras

int SEUIL = 10;

float[] x = new float[M+1];
float[] y = new float[M+1];
float[] a = new float[M+1];

float ls,d,da,db,ang;
int i,j;
int xb,yb; // coord du but (la souris)

void setup(){
  size(600,600);
  frameRate(1);
  ellipseMode(CENTER);
  noFill();
  //translate(300,300);
  ls = float(L)/float(M); //longueur d'un segment
  x[0] = 0.0;y[0] = 0.0;a[0] = 0.0;
  for (int i=1; i<=M; i++){
    x[i] = x[i-1]+ls;
    y[i] = 0.0;
    a[i] = 0.0;
  }
   colorMode(HSB);
   i = M-1;
}


void draw(){

 background(0,0,0);
 stroke(255,255,255);
 strokeWeight(1);
 translate(300,300);
 ellipse(0,0,2*L,2*L);

 // but = rattraper la souris
 xb = mouseX - 300; 
 yb = mouseY - 300;
 
 // dessin de la chaine
 strokeWeight(4);
 for (j=0;j<M;j++){
  stroke(255*j/M,255,255);
  line(x[j],y[j],x[j+1],y[j+1]);
 }
 strokeWeight(1); 
 stroke(255,255,255);
 ellipse(x[M],y[M],2*SEUIL,2*SEUIL);
 
 d = (xb*xb + yb*yb);  //test sur la faisabilite 
 db = ((xb-x[M])*(xb-x[M])+(yb-y[M])*(yb-y[M]));  // but atteint ?
 
 if ((d < L*L)&&(db > SEUIL*SEUIL)) {
    da = angle(x[i],y[i],x[M],y[M],xb,yb);
    stroke(255,0,255);
    line(x[i],y[i],x[M],y[M]);
    line(x[i],y[i],xb,yb);
    a[i] += da;
    // nouvelles coords des segments
    ang = 0;
    for (j=1; j<=M; j++){
      ang += a[j-1];
      if (j>=i){
       x[j] = x[j-1] + ls*cos(ang);
       y[j] = y[j-1] + ls*sin(ang);
      }
    }
    i--;
    if (i < 0) i = M-1;
 }
 else {
   println("###### RIEN A FAIRE distance^2 = "+ db);
   i = M-1;
 }
}

float angle(float x1,float y1,float x2,float y2,float x3,float y3) {
 float ps = (x2-x1)*(x3-x1)+(y2-y1)*(y3-y1);
 float na = sqrt(abs((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)));
 float nb = sqrt(abs((x3-x1)*(x3-x1)+(y3-y1)*(y3-y1)));
 float alph;
 if ((na > 0)&&(nb > 0)){
  float r = ps/na/nb;
  if (abs(r)<=1) alph = acos(r); else alph = 0;
 }
 else {alph=0;}
 if ((x2-x1)*(y3-y1) < (y2-y1)*(x3-x1)) { alph = -alph;}
 ////////println(ps+" "+na+" "+nb+" "+alph);
 return alph;
}
